unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls
  , RichMemo, CarbonRichMemo, MacOSAll;

type

  { TForm1 }

  TForm1 = class(TForm)
    RichMemo1: TRichMemo;
    ScrollBox1: TScrollBox;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure RichMemo1Change(Sender: TObject);
    procedure RichMemo1SelectionChange(Sender: TObject);
    procedure ScrollBox1Resize(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

procedure RMToScrollBox(RM: TRichMemo; Box: TScrollBox);
var
  v   : HIViewRef;
  obj : TXNObject;
  r   : TXNLongRect;
  vr  : MacOSAll.Rect;
  dr  : TXNLongRect;
  h,w : Integer;
  hsc : Boolean;
  vsc : Boolean;
  mv  : integer;
  mh  : integer;
  t   : integer;
  th, tw : integer;
begin
  RM.Left:=0;
  RM.Top:=0;
  v:=TCarbonRichEdit(RM.Handle).Widget;
  obj:=HITextViewGetTXNObject(v);
  TXNGetRectBounds(obj, @vr, @dr, @r);
  tw:=r.right-r.left;
  th:=r.bottom-r.top;
  if not RM.WordWrap then begin
    w:=tw;
    hsc:=w>Box.ClientWidth;
    if not hsc then w:=Box.ClientWidth;
  end else begin
    w:=Box.ClientWidth;
    hsc:=false;
  end;

  h:=th;
  if Box.ClientHeight>h then begin
    h:=Box.ClientHeight;
    vsc:=false;
  end else
    vsc:=true;

  mv:=h;
  mh:=w;
  if hsc then mv:=mv+Box.HorzScrollBar.Size;
  if vsc then mh:=mh+Box.VertScrollBar.Size;

  // Carbon feature: Range must be less than page to make scroll bar disappear!
  if not hsc then mh:=0; //and (Box.HorzScrollBar.Range >= Box.HorzScrollBar.Page) then mn:=0;
  if Box.HorzScrollBar.Range<>mh then Box.HorzScrollBar.Range:=mh;
  t:=Box.VertScrollBar.ClientSizeWithBar;
  if (mh>0) and (Box.HorzScrollBar.Page<>t) then
    Box.HorzScrollBar.Page:=t; // adjusting page

  if not vsc then mv:=0;
  if Box.VertScrollBar.Range<>mv then Box.VertScrollBar.Range:=mv;
  t:=Box.HorzScrollBar.ClientSizeWithBar;
  if (mv>0) and (Box.VertScrollBar.Page<>t) then
    Box.VertScrollBar.Page:=t;

  if (w<>RM.Width) or (h<>RM.Height) then RM.SetBounds(0, 0, w, h);
end;

procedure FocusRMToScrollBox(RM: TRichMemo; Box: TScrollBox);
var
  v    : HIViewRef;
  obj  : TXNObject;
  p    : HIPoint;
  sofs : TXNOffset;
  eofs : TXNOffset;
  vr   : TRect;
  nx   : integer;
  ny   : integer;
  w,h  : Fixed;
  lh   : integer;
begin
  v:=TCarbonRichEdit(RM.Handle).Widget;
  obj:=HITextViewGetTXNObject(v);
  TXNGetSelection(obj, sofs, eofs);
  TXNOffsetToHIPoint(obj, eofs, p);

  vr.Left:=Box.HorzScrollBar.Position;
  vr.Top:=Box.VertScrollBar.Position;
  if Box.VertScrollBar.Range>0
    then vr.Right:=vr.Left+Box.VertScrollBar.ClientSizeWithBar
    else vr.Right:=vr.Left+Box.VertScrollBar.ClientSizeWithoutBar;
  if Box.HorzScrollBar.Range>0
    then vr.Bottom:=vr.Top+Box.HorzScrollBar.ClientSizeWithBar
    else vr.Bottom:=vr.Top+Box.HorzScrollBar.ClientSizeWithoutBar;

  // inaccurate. but good enough... for the workaround
  TXNGetLineMetrics(obj, 0, w, h);
  lh:=Fix2Long(h);
  vr.Bottom:=vr.Bottom-lh;

  if (p.x<vr.left) or (p.x>vr.Right) then begin
    nx:=round(p.x-Box.HorzScrollBar.Page);
    if nx<0 then nx:=0;
  end else
    nx:=-1;

  if (p.y<vr.Top) or (p.y>vr.Bottom) then begin
    ny:=round(p.y-(Box.VertScrollBar.Page-lh));
    if ny<0 then ny:=0;
  end else
    ny:=-1;

  if nx>=0 then Box.HorzScrollBar.Position:=nx;
  if ny>=0 then Box.VertScrollBar.Position:=ny;

  // sorry. the partial redrawing is so buggy! forcing full redrawing
  RM.Invalidate;
end;

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  RMToScrollBox(RichMemo1, ScrollBox1);
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  RMToScrollBox(RichMemo1, ScrollBox1);
end;

procedure TForm1.RichMemo1Change(Sender: TObject);
begin
  RMToScrollBox(RichMemo1, ScrollBox1);
  FocusRMToScrollBox(RichMemo1, ScrollBox1);
end;

procedure TForm1.RichMemo1SelectionChange(Sender: TObject);
begin
  FocusRMToScrollBox(RichMemo1, ScrollBox1);
end;

procedure TForm1.ScrollBox1Resize(Sender: TObject);
begin
  RMToScrollBox(RichMemo1, ScrollBox1);
end;

end.

